import bearssl

import ../../jwt/jwa
import ../../jwt/jwk

proc bearRsaSign(
    alg: JwtAlgorithm,
    key: RsaPrivateKey,
    toSign: string
  ): string =

  var hashVtable: ptr HashClass
  var hashOID: cstring

  case alg:
    of RS256: hashVtable = addr sha256Vtable; hashOID = HASH_OID_SHA256
    of RS384: hashVtable = addr sha384Vtable; hashOID = HASH_OID_SHA384
    of RS512: hashVtable = addr sha512Vtable; hashOID = HASH_OID_SHA512
    else: raise newException(ValueError,
      "Unsupported RSA signature algorithm '" & $alg & "'")

  # TODO
  ""
