import std/json, std/options, std/unittest

import jwt/jwa
import jwt/joseheader

import ../testdata

suite "jwt/joseheader":

  test "initJoseHeader always sets rawB64":
    let h1 = initJoseHeader(rfc7519Sec3_1ExampleHeaderB64)
    let h2 = initJoseHeader(parseJson(rfc7519Sec3_1ExampleHeaderStr))
    let h3 = initJoseHeader(alg = some(HS256), typ = some("JWT"))

    check:
      h1.rawB64 == rfc7519Sec3_1ExampleHeaderB64
      h2.rawB64 == "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9"
      h3.rawB64 == "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9"
